unit Unit1;

{
 MSUI. Przyklad z cwiczen o programowaniu obiektowym.

 Co jest warte zwrocenia uwagi w tym programie:
   - przede wszystkim fragment

        for i:= 1 to n do
         begin
          tab[i].x := tab[i].x +10;
          tab[i].y := tab[i].y + 5;
         end;

     Wykonujemy tu przypisanie na atrybuty x,y, ktorych nie ma zadna z podklas
     klasy TFigura. Ponadto tablica tab jest zadeklarowana jako zawierajaca
     obiekty TFigura, a ta klasa jest abstrakcyjna wiec nie ma w ogole obiektow!
   - konstruktory (i uzycie inherited),
   - destruktory,
   - czesci modulu initialization i finalization,
   - dziedziczenie,
   - obsluge zdarzenia OnPaint formularza. 


 Co nie jest warte uwagi:
   - grafika.

 Co warto by bylo dorobic:
   - obiekty powinny dac o to, by nie wychodzic poza brzegi okienka,
   - ruch obiektow moglby byc generowany tyknieciami zegara (TTimer),
   - kolory powinny byc atrybutami poszczegolnych obiektow,
   - po wykonaniu ruchu warto odswiezyc (show) wszystkie obiekty (zwn
       na wzajemne zaslanianie),
   - mozna by dac uzytkownikowi mozliwosc wyboru liczby i rodzajow
       obiektow wystepujacych w programie,
   - elegantszym od przedstawionego rozwiazanim jest pamietanie w kazdym
        obiekcie na powierzchni jakiego obiektu ma sie rysowac.


}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Ruch: TButton;
    Koniec: TButton;
    procedure RuchClick(Sender: TObject);
    procedure KoniecClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//************************ Nasze deklaracje *****************************

type TFigura = class
        private
          xx, yy : integer;  // Polozenie na plotnie
          constructor Create(_xx:integer; _yy:integer);
          procedure setx(_x:integer);
          procedure sety(_y:integer);
        public
          procedure show; virtual; abstract;
          procedure hide; virtual; abstract;
          property x:integer read xx write setx;
          property y:integer read yy write sety;
        end;

     TProstokat = class (TFigura)
        private
          rx, ry: integer;
        public
          constructor Create(_xx:integer; _yy:integer; _rx:integer; _ry:integer);
          procedure show; override;
          procedure hide; override;
        end;

     TKwadrat = class (TProstokat)
        public
          procedure show; override;
          constructor Create(_xx:integer; _yy:integer; _r:integer);
        end;

     TKolo = class (TFigura)
        private
          r : integer;
        public
         constructor Create(_xx:integer; _yy:integer; _r:integer);
         procedure show; override;
         procedure hide; override;
        end;

implementation

{$R *.DFM}

const
     n = 5;

var
  tab : array[1..n] of TFigura;  // Tablica poruszanych figur

//************************ TFigura *****************************

constructor TFigura.Create(_xx:integer; _yy:integer);
  begin
    inherited Create;
    xx := _xx;
    yy := _yy;
  end;

procedure TFigura.setx(_x:integer);
  begin
    Hide;
    xx := _x;
    Show;
  end;

procedure TFigura.sety(_y:integer);
  begin
    Hide;
    yy := _y;
    Show;
  end;

//************************ TProstokat *****************************

constructor TProstokat.Create(_xx:integer; _yy:integer; _rx:integer; _ry:integer);
  begin
    inherited Create(_xx,_yy);
    rx := _rx;
    ry := _ry;
  end;

procedure TProstokat.show;
  begin
    Form1.Canvas.Brush.Color := clyellow;
    Form1.Canvas.Pen.Color   := clyellow;
    Form1.Canvas.Rectangle(xx, yy, xx+rx, yy + ry);
  end;

procedure TProstokat.hide;
  begin
    Form1.Canvas.Brush.Color := Form1.Brush.Color;
    Form1.Canvas.Pen.Color   := Form1.Brush.Color;
    Form1.Canvas.Rectangle(xx, yy, xx+rx, yy + ry);
  end;

//************************ TKwadrat *****************************

constructor TKwadrat.Create(_xx:integer; _yy:integer; _r:integer);
  begin
    inherited Create(_xx,_yy, _r, _r);
  end;

procedure TKwadrat.show;
  begin
    Form1.Canvas.Brush.Color := clblue;
    Form1.Canvas.Pen.Color   := clblue;
    Form1.Canvas.Rectangle(xx, yy, xx+rx, yy + ry);
  end;

//************************ TKolo *****************************

constructor TKolo.Create(_xx:integer; _yy:integer; _r:integer);
  begin
    inherited Create(_xx,_yy);
    r := _r;
  end;

procedure TKolo.show;
  begin
    Form1.Canvas.Brush.Color := clgreen;
    Form1.Canvas.Pen.Color   := clgreen;
    Form1.Canvas.ellipse(xx, yy, xx+r, yy + r);
  end;

procedure TKolo.hide;
  begin
    Form1.Canvas.Brush.Color := Form1.Brush.Color;
    Form1.Canvas.Pen.Color   := Form1.Brush.Color;
    Form1.Canvas.Rectangle(xx, yy, xx+r, yy + r);
  end;

//************************ TForm1 *****************************

procedure TForm1.RuchClick(Sender: TObject);
   var i : integer;
  begin
    for i:= 1 to n do
     begin
      tab[i].x := tab[i].x +10;
      tab[i].y := tab[i].y + 5;
     end;
  end;

procedure TForm1.KoniecClick(Sender: TObject);
  begin
    close
  end;

procedure TForm1.FormPaint(Sender: TObject);
   var
    i: integer;
  begin
    for i := 1 to n do
      tab[i].show;
  end;

var
 i: integer;

initialization

    randomize;

    for i:= 1 to n  do
      case random(3) of
       0: tab[i] := TProstokat.Create(i*30,i*30,100,25);
       1: tab[i] := TKwadrat.Create(i*30,i*30,25);
       2: tab[i] := TKolo.Create(i*30,i*30,20);
      end;

finalization

    for i:= 1 to n  do
       tab[i].free;

end.
